<!-- -*- mode: HTML -*- -->
<HTML>
<HEAD>

<!-- Please preserve look n' feel! -->

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 3.2//EN">

<TITLE>stageData meta macro</TITLE>

<META name="description"
   content="Description of the stageData User Command">

<META name="keywords"
   content="macros, commands, user">

</HEAD>

<BODY BGCOLOR="#DDDDDD" TEXT="#000000">
<a name="top">
<table>
<td width=100%><td>
<IMG SRC="/doc/gifs/LIGO.gif" ALIGN=right ALT="LIGO.gif">
</table>

<h3> The <i>stageData</i> User Command (Meta Macro) </h3>
<b>All user commands have the form:</b>
<p>
<tt><font color="red">
<b>ldasJob</b> { -name {} -password {} -email {} } { <b>userCmd</b> -opt1 {} ... }
</tt></font>
<p>
Which is in the format of a 
<a href=http://www.tcl.tk><b>Tcl</b></a>
command, <b>ldasJob</b>, with two required arguments:
<ol>
<li>
A Tcl list of <b>user information</b> consisting of username,
password, and e-mail address.  All fields must be filled or
the command will be rejected.<br>
Client software which would like to receive responses from the
LDAS system on a port instead of through email can provide a
<b>hostname:port</b> combination as the email argument.  A
further feature of this method is that the hostname can be replaced
with the magic key <b>!host!</b>, and the LDAS system will use
the IP address it finds by doing a peername lookup on the
connected socket.
<li>
A <b>user command</b> in the form of a Tcl list, for which there
exists a &quot;meta&quot; macro file which can be expanded into Tcl code
which can then be evaluated by the LDAS system.
<br>
The user command consists of the command name, <b><i>stageData</i></b>,
followed by a series of options and their values.  To determine which
options are required for a given process pipeline you will need to
study the descriptions of the various options carefully.
<br>
Some option fields will accept a &quot;null&quot; argument consisting of
a matching pair of braces <b>&quot;{}&quot;</b> with no interposed space.
<br>
Meta macros consist of a prototype declaration of the arguments
for the given user command, and a template describing the calling
order of API specific blocks of Tcl code which are concatenated
into a larger block comprising the complete request, which can
then be distributed by the assistant manager for interpretation
by the low level API's.
<br>
These API specific blocks are maintained as API specific macro
files consisting of immediately interpretable Tcl code.
</ol>
There is a special user command which makes it possible to move
remote data to an LDAS installation's local file system for
subsequent use:
<ul>
<a href="#stagedata"><li><b><i>stageData</i></b></a>
</ul>
<!-- bottom of page pointer section --> 
<center>
<h2>
<a href="#stagedata">stageData</a>
<IMG SRC="/doc/gifs/arrow_right.gif" ALT="Back to Top">
</h2>
</center>
<!-- Here we put the stuff which will become the linked pages --> 
<hr>
<ul>
<li>
<a name="stagedata">
<b><i>stageData</i></b>
<p>
Localises remote data which is specified via http, ftp, or file
URL's into a specified location under the directory hierarchy
that is visible to all LDAS API servers.<br>
If -subdirectory is specified it will be forced
relative to $::PUBDIR, which is normally /ldas_outgoing/jobs.
<p>

<p><p>
The e-mail message returned to the user at the completion of the job
can be parsed to determine the location and local names of the files:
<p>
<ul>
<pre><font color=brown>
      Your results:
      LDAS-DEV10472480_wrapperdata.ilwd
      can be found at:
      ftp://131.215.115.248/LDAS-DEV_1047/LDAS-DEV10472480
</font></pre>
</ul>
<p>&nbsp;<p>
<b><font color=green>
Calling convention (all on a single line):
</font></b>
<p>
<b>ldasJob</b>&nbsp;
<b>{&nbsp;</b>
-name&nbsp;<i>"username"</i>&nbsp;
-password&nbsp;<i>"********"</i>&nbsp; 
-email&nbsp;<i>"user@foobar.edu"</i><b>&nbsp;}</b>&nbsp; 
<b>{&nbsp;<i>stageData</i></b>&nbsp;
<a href=#urls>-urls</a>
&nbsp;<font color="red"> <i>Tcl list of URL's</i></font>&nbsp; 
<a href=#subdirectory>-subdirectory</a>
&nbsp;<font color="red"> <i>subdirectory name</i></font>&nbsp;
<a href=#returnprotocol>-returnprotocol</a>
&nbsp;<font color="red"> <i>ftp, http or {}</i></font>&nbsp;
<a href=#overwrite>-overwrite</a>
&nbsp;<font color="red"> <i>1, 0 or -1</i></font>&nbsp;
<a href=#cleanup>-cleanup</a>
&nbsp;<font color="red"> <i>1 or 0</i></font>&nbsp;
<a href=#subject>-subject</a>
&nbsp;<font color="red"> <i>{freeform string}</i></font>&nbsp;
<b>}</b>
<p>
<font color="green">Option Descriptions:</font>
<ul>
<p><p>
<a name=urls>
<b>-urls:</b> &nbsp; &nbsp; <tt>{ list of valid URL's }</tt>
<p>
<ul>
<font color=red>
Required
</font><br>
<tt>
Valid URL's are ftp and http URL's that are on anonymously
accessible servers.
</tt>
</ul>
<p>
<a name=subdirectory>
<b>-subdirectory:</b> &nbsp; &nbsp; <tt>subdirectory</tt>
<p>
<ul>
<font color=red>
Optional
</font><br>
<tt>
Specify when you want the transferred files to  be written into
a user specified directory and not into the normal job directory
hierarchy.
<p>
You want to specify the subdirectory if you are transferring data
which will subsequently be used many times and you are sure that
the files will not be overwritten by yourself or another user.
</tt>
</ul>
<p>
<a name=overwrite>
<b>-overwrite:</b> &nbsp; &nbsp; <tt>[ -1 0 1 ]</tt>
<p>
<ul>
<font color=red>
Optional, defaults to <b>1</b>
</font><br>
<tt>
Possible values and their implications:
   <ul>
     <li><b>-1</b>&nbsp;&nbsp;&nbsp;existing files will be overwritten
     with no <b>.bak</b> files created.<p>
     <li><b>0</b>&nbsp;&nbsp;&nbsp;existing files will not be overrwitten,
     an exception will be raised if a new file would otherwise have
     resulted in an overwrite.<p>
     <li><b>1</b>&nbsp;&nbsp;&nbsp;existing files will be renamed using
     the <b>.bak, .ba2 .ba3 ...</b> extensions to a depth of <b>10</b>
     backups.  All files will be rotated through the backup sequence so
     that the oldest file will have the highest numbered extension.
   </ul>
</tt>
</ul>
<p>
<a name=cleanup>
<b>-cleanup:</b> &nbsp; &nbsp; <tt>[ 0 1 ]</tt>
<p>
<ul>
<font color=red>
Optional, defaults to <b>1</b>
</font><br>
<tt>
Possible values and their implications:
   <ul>
     <li><b>0</b>&nbsp;&nbsp;&nbsp;local copies of remote URL's will be
     retained in the jobid specific subdirectory even if the
     <b>-subdirectory</b> option was used.  This is generally not a
     useful thing, and is a waste of disk space.<p>
     <li><b>1</b>&nbsp;&nbsp;&nbsp;local copies of remote URL's will be
     removed from the jobid specific directory at the time that they
     are copied into the directory specified by <b>-subdirectory</b>.
     <br>
     if a subdirectory is not specified this option has no effect.
   </ul>
</tt>
</ul>
<p>
<a name=returnprotocol>
<b>-returnprotocol:</b> &nbsp; &nbsp; <tt>http ftp</tt>
<p>
<ul>
<font color=red>
Optional, defaults to 'file'
</font><br>
<tt>
When set to http or ftp, the return message will contain a URL
which can be used to refer to the data in future user commands
processed by the local LDAS system or any remote LDAS system.
<p>
The default behaviour is to return a local path which is only
usable for referencing the data from the local LDAS.
<p>
In any case, this option is provided to aid in the development
of automated scripts for driving LDAS jobs, by providing them
with valid URL's which can be parsed or published on the web
as links.
</tt>
</ul>
<p>
<a name=subject>
<b>-subject:</b> &nbsp; &nbsp; <tt>freeform string</tt>
<p>
<ul>
<font color=red>
Optional, defaults to 'results'
</font><br>
<tt>
Used as the subject line in the email returned after successful
completion of the user command.
</tt>
</ul>
<p>
<center>
<h2>
<IMG SRC="/doc/gifs/arrow_up.gif" ALT="Back to Top">
<a href="#top">Return to Top</a>
<IMG SRC="/doc/gifs/arrow_up.gif" ALT="Back to Top">
</h2>
</center>

<!-- End of dataStandAlone --> 

</BODY>

<!-- VI POWERED! -->

</HTML>
